LYLOCK_VERSION = "v1.3"
LYLOCK_DISABLE = false
LYLOCK_DEBUG = false

LyLock_Settings = {}

--------------------------------------------------------------------------------------
-- Variables and Constants -----------------------------------------------------------
--------------------------------------------------------------------------------------
LYLOCK_FLAGCAST = "X"
LYLOCK_FLAGMAKE = "C"
LYLOCK_FLAGNONE = ""

LYLOCK_COLORSCHEMES = {
	"Pinky",
	"Wings",
	"Blast",
	"Trees"
}

function SetColorScheme(scheme)
	scheme=string.lower(scheme)
	if scheme=="pinky" then
		COLOR_NORMAL ="|CFFFFFFFF"
		COLOR_ERROR = "|CFFFF00FF"
		COLOR_HEADER = "|CFFFF99FF"
		COLOR_VALUE = "|CFFFF99FF"
		COLOR_NOTIFY = "|CFFFFC4FF"
		COLOR_TITLE = "|CFFFF50FF"
		COLOR_BRACKET = "|CFFB700B7"
	elseif scheme=="blast" then
		COLOR_NORMAL = "|CFFFFFFFF"
		COLOR_ERROR = "|CFFFF6600"
		COLOR_HEADER = "|CFFFFCC00"
		COLOR_VALUE = "|CFFFFCC00"
		COLOR_NOTIFY = "|CFFFFD387"
		COLOR_TITLE = "|CFFFF3300"
		COLOR_BRACKET = "|CFFDE8800"
	elseif scheme=="trees" then
		COLOR_NORMAL = "|CFFFFFFFF"
		COLOR_ERROR = "|CFF00FF00"
		COLOR_HEADER = "|CFF81FF43"
		COLOR_VALUE = "|CFF81FF43"
		COLOR_NOTIFY = "|CFFCCFF66"
		COLOR_TITLE = "|CFF00FA00"
		COLOR_BRACKET = "|CFFFFFF66"
	elseif scheme=="wings" then
		COLOR_NORMAL = "|CFFEBEBFF"
		COLOR_ERROR = "|CFF4040FF"
		COLOR_HEADER = "|CFF8080FF"
		COLOR_VALUE = "|CFF8080FF"
		COLOR_NOTIFY = "|CFFC0C0FF"
		COLOR_TITLE = "|CFF2065C2"
		COLOR_BRACKET = "|CFF01059D"
	end

end

LyLock_MessageDefaults = {}
LyLock_MessageDefaults.Summoning_Message1 = "Summoning %target%, click the portal";
LyLock_MessageDefaults.Summoning_Message2 = "OMG! Where did this horse come from!";
LyLock_MessageDefaults.Soulstone_Message1 = "Casting Soulstone on %target%";
LyLock_MessageDefaults.Soulstone_Message2 = "FYI: You have been soulstoned";
LyLock_MessageDefaults.Soulstone_Message3 = "FYI: %target% has been soulstoned";
LyLock_MessageDefaults.Banish_Message1 = "Banish is on %target%";
LyLock_MessageDefaults.Banish_Message2 = "Banish is fading NOW";
LyLock_MessageDefaults.Banish_Message3 = "Banish has faded EARLY";
LyLock_MessageDefaults.Banish_Message4 = "FYI: %player% died while Banishing %target%!";


function LyLock_Defaults()
	LYLOCK_DISABLE = (UnitClass("player")~="Warlock")

	if LYLOCK_DISABLE then
		DEFAULT_CHAT_FRAME:AddMessage("|CFFFF0000ATTENTION!!!! LyLock is disabling because this character is not a warlock.  However it is a better idea to disable this add-on for this character from the add-on screen as it will save a little memory during game play.")
		LyLockFrame:Hide();
		return false
	else

		------------------------------------------------------
		-- Configuration Settings ----------------------------
		------------------------------------------------------

		LyLock_Settings.Visual_LockFrames = ReturnSetting(LyLock_Settings.Visual_LockFrames, false)
		LyLock_Settings.Visual_ColorScheme = ReturnSetting(LyLock_Settings.Visual_ColorScheme, "Wings")
		
		LyLock_Settings.Visual_VerticalBar = ReturnSetting(LyLock_Settings.Visual_VerticalBar, false)
		LyLock_Settings.Visual_ButtonSize = ReturnSetting(LyLock_Settings.Visual_ButtonSize, 33)
		LyLock_Settings.Visual_ButtonSpace = ReturnSetting(LyLock_Settings.Visual_ButtonSpace, 6)
		
		LyLock_Settings.SoulShard_UseBag0 = ReturnSetting(LyLock_Settings.SoulShard_UseBag0, false)
		LyLock_Settings.SoulShard_UseBag1 = ReturnSetting(LyLock_Settings.SoulShard_UseBag1, false)
		LyLock_Settings.SoulShard_UseBag2 = ReturnSetting(LyLock_Settings.SoulShard_UseBag2, false)
		LyLock_Settings.SoulShard_UseBag3 = ReturnSetting(LyLock_Settings.SoulShard_UseBag3, false)
		LyLock_Settings.SoulShard_UseBag4 = ReturnSetting(LyLock_Settings.SoulShard_UseBag4, false)

		
		------------------------------------------------------
		-- Demon Armor Settings ------------------------------
		------------------------------------------------------

		LyLock_Settings.DemonArmor_ReadyUse = ReturnSetting(LyLock_Settings.DemonArmor_ReadyUse, true)
		LyLock_Settings.DemonArmor_Unbuffed = ReturnSetting(LyLock_Settings.DemonArmor_Unbuffed, 10)

		------------------------------------------------------
		-- Summon Settings -----------------------------------
		------------------------------------------------------
		
		LyLock_Settings.Summoning_Casting = ReturnSetting(LyLock_Settings.Summoning_Casting, true)
		LyLock_Settings.Summoning_Mounting = ReturnSetting(LyLock_Settings.Summoning_Mounting, false)
		LyLock_Settings.Summoning_Message1 = ReturnSetting(LyLock_Settings.Summoning_Message1, LyLock_MessageDefaults.Summoning_Message1)
		LyLock_Settings.Summoning_Message2 = ReturnSetting(LyLock_Settings.Summoning_Message2, LyLock_MessageDefaults.Summoning_Message2)
		
		------------------------------------------------------
		-- Healthstone Settings ------------------------------
		------------------------------------------------------

		LyLock_Settings.Healthstone_UseCombat = ReturnSetting(LyLock_Settings.Healthstone_UseCombat, true)
		LyLock_Settings.Healthstone_HealthCap = ReturnSetting(LyLock_Settings.Healthstone_HealthCap, true)
		LyLock_Settings.Healthstone_TradeRequest = ReturnSetting(LyLock_Settings.Healthstone_TradeRequest, true)
		LyLock_Settings.Healthstone_TradeCombat = ReturnSetting(LyLock_Settings.Healthstone_TradeCombat, false)
		LyLock_Settings.Healthstone_TradeRaiding = ReturnSetting(LyLock_Settings.Healthstone_TradeRaiding, true)

		------------------------------------------------------
		-- Soulsone Settings ---------------------------------
		------------------------------------------------------

		LyLock_Settings.Soulstone_Cooldown = ReturnSetting(LyLock_Settings.Soulstone_Cooldown, true)
		LyLock_Settings.Soulstone_Unbuffed = ReturnSetting(LyLock_Settings.Soulstone_Unbuffed, 5)
		LyLock_Settings.Soulstone_WarnSelf = ReturnSetting(LyLock_Settings.Soulstone_WarnSelf, 0)
	
		LyLock_Settings.Soulstone_Casting = ReturnSetting(LyLock_Settings.Soulstone_Casting, true)
		LyLock_Settings.Soulstone_Whisper = ReturnSetting(LyLock_Settings.Soulstone_Whisper, true)
		LyLock_Settings.Soulstone_Warlocks = ReturnSetting(LyLock_Settings.Soulstone_Warlocks, true)
		
		LyLock_Settings.Soulstone_Message1 = ReturnSetting(LyLock_Settings.Soulstone_Message1, LyLock_MessageDefaults.Soulstone_Message1)
		LyLock_Settings.Soulstone_Message2 = ReturnSetting(LyLock_Settings.Soulstone_Message2, LyLock_MessageDefaults.Soulstone_Message2)
		LyLock_Settings.Soulstone_Message3 = ReturnSetting(LyLock_Settings.Soulstone_Message3, LyLock_MessageDefaults.Soulstone_Message3)


		------------------------------------------------------
		-- Banish Settings -----------------------------------
		------------------------------------------------------
	
		LyLock_Settings.Banish_Disable = ReturnSetting(LyLock_Settings.Banish_Disable, false)
		LyLock_Settings.Banish_Countdown = ReturnSetting(LyLock_Settings.Banish_Countdown, true)
		LyLock_Settings.Banish_Casting = ReturnSetting(LyLock_Settings.Banish_Casting, false)
		LyLock_Settings.Banish_Fading = ReturnSetting(LyLock_Settings.Banish_Fading, true)
		LyLock_Settings.Banish_Warlocks = ReturnSetting(LyLock_Settings.Banish_Warlocks, false)

		LyLock_Settings.Banish_Message1 = ReturnSetting(LyLock_Settings.Banish_Message1, LyLock_MessageDefaults.Banish_Message1)
		LyLock_Settings.Banish_Message2 = ReturnSetting(LyLock_Settings.Banish_Message2, LyLock_MessageDefaults.Banish_Message2)
		LyLock_Settings.Banish_Message3 = ReturnSetting(LyLock_Settings.Banish_Message3, LyLock_MessageDefaults.Banish_Message3)
		LyLock_Settings.Banish_Message4 = ReturnSetting(LyLock_Settings.Banish_Message4, LyLock_MessageDefaults.Banish_Message4)				
				

		return true

	end
end

function LyLock_SettingsFrameAction(action)
		
	if action=="Open" then LyLock_LoadSettingsFrame(); LyLockConfigFrame:Show(); end
	
	if action=="DemonArmor" then DemonArmorOptionsFrame:Show(); else DemonArmorOptionsFrame:Hide(); end
	
	if action=="Healthstone" then HealthstoneOptionsFrame:Show(); else HealthstoneOptionsFrame:Hide(); end
	
	if action=="Summon" then SummonOptionsFrame:Show(); else SummonOptionsFrame:Hide(); end
	if action=="Summon" then SummonMessageFrame:Show(); else SummonMessageFrame:Hide(); end
	
	if action=="Soulstone" then SoulstoneOptionsFrame:Show(); else SoulstoneOptionsFrame:Hide(); end
	if action=="Soulstone" then SoulstoneMessageFrame:Show(); else SoulstoneMessageFrame:Hide(); end
	
	if action=="Banish" then BanishOptionsFrame:Show(); else BanishOptionsFrame:Hide(); end
	if action=="Banish" then BanishMessageFrame:Show(); else BanishMessageFrame:Hide(); end
	
	if action=="Visual" or action=="Open" then VisualOptionsFrame:Show(); else VisualOptionsFrame:Hide(); end
	
	if action=="Confirm" then LyLock_SaveSettingsFrame(); end
	if action=="Cancel" or action=="Confirm" then LyLockConfigFrame:Hide(); end

end

function LyLock_SaveSettingsFrame()
	LyLock_Settings.DemonArmor_ReadyUse = iif(DemonArmor_ReadyUse:GetChecked(), true, false);
	LyLock_Settings.DemonArmor_Unbuffed = iif(DemonArmor_Unbuffed:GetChecked(), 10, 0);

	LyLock_Settings.Healthstone_UseCombat = iif(Healthstone_UseCombat:GetChecked(), true, false);
	LyLock_Settings.Healthstone_HealthCap = iif(Healthstone_HealthCap:GetChecked(), true, false);
	LyLock_Settings.Healthstone_TradeRequest = iif(Healthstone_TradeRequest:GetChecked(), true, false);
	LyLock_Settings.Healthstone_TradeCombat = iif(Healthstone_TradeCombat:GetChecked(), true, false);
	LyLock_Settings.Healthstone_TradeRaiding = iif(Healthstone_TradeRaiding:GetChecked(), true, false);

	LyLock_Settings.Summoning_Casting = iif(Summoning_Casting:GetChecked(), true, false);
	LyLock_Settings.Summoning_Mounting = iif(Summoning_Mounting:GetChecked(), true, false);
	LyLock_Settings.Summoning_Message1 = ReturnSetting(Summoning_Message1:GetText(), LyLock_MessageDefaults.Summoning_Message1);
	LyLock_Settings.Summoning_Message2 = ReturnSetting(Summoning_Message2:GetText(), LyLock_MessageDefaults.Summoning_Message2);
	
	LyLock_Settings.Soulstone_Cooldown = iif(Soulstone_Cooldown:GetChecked(), true, false);
	LyLock_Settings.Soulstone_Unbuffed = iif(Soulstone_Unbuffed:GetChecked(), 5, 0);
	LyLock_Settings.Soulstone_WarnSelf = iif(Soulstone_WarnSelf:GetChecked(), 5, 0);
	LyLock_Settings.Soulstone_Casting = iif(Soulstone_Casting:GetChecked(), true, false);
	LyLock_Settings.Soulstone_Whisper = iif(Soulstone_Whisper:GetChecked(), true, false);
	LyLock_Settings.Soulstone_Warlocks = iif(Soulstone_Warlocks:GetChecked(), true, false);
	
	LyLock_Settings.Soulstone_Message1 = ReturnSetting(Soulstone_Message1:GetText(), LyLock_MessageDefaults.Soulstone_Message1);
	LyLock_Settings.Soulstone_Message2 = ReturnSetting(Soulstone_Message2:GetText(), LyLock_MessageDefaults.Soulstone_Message2);
	LyLock_Settings.Soulstone_Message3 = ReturnSetting(Soulstone_Message3:GetText(), LyLock_MessageDefaults.Soulstone_Message3);

	LyLock_Settings.Banish_Disable = iif(Banish_Disable:GetChecked(), true, false);
	LyLock_Settings.Banish_Countdown = iif(Banish_Countdown:GetChecked(), true, false);
	LyLock_Settings.Banish_Casting = iif(Banish_Casting:GetChecked(), true, false);
	LyLock_Settings.Banish_Fading = iif(Banish_Fading:GetChecked(), true, false);
	LyLock_Settings.Banish_Warlocks = iif(Banish_Warlocks:GetChecked(), true, false);

	LyLock_Settings.Banish_Message1 = ReturnSetting(Banish_Message1:GetText(), LyLock_MessageDefaults.Banish_Message1);
	LyLock_Settings.Banish_Message2 = ReturnSetting(Banish_Message2:GetText(), LyLock_MessageDefaults.Banish_Message2);
	LyLock_Settings.Banish_Message3 = ReturnSetting(Banish_Message3:GetText(), LyLock_MessageDefaults.Banish_Message3);
	LyLock_Settings.Banish_Message4 = ReturnSetting(Banish_Message4:GetText(), LyLock_MessageDefaults.Banish_Message4);
	
	LyLock_Settings.SoulShard_UseBag0 = iif(SoulShard_UseBag0:GetChecked(), true, false);
	LyLock_Settings.SoulShard_UseBag1 = iif(SoulShard_UseBag1:GetChecked(), true, false);
	LyLock_Settings.SoulShard_UseBag2 = iif(SoulShard_UseBag2:GetChecked(), true, false);
	LyLock_Settings.SoulShard_UseBag3 = iif(SoulShard_UseBag3:GetChecked(), true, false);
	LyLock_Settings.SoulShard_UseBag4 = iif(SoulShard_UseBag4:GetChecked(), true, false);
	
	if Visual_ColorSchemePinky:GetChecked() then
		LyLock_Settings.Visual_ColorScheme = "Pinky"
	elseif Visual_ColorSchemeWings:GetChecked() then
		LyLock_Settings.Visual_ColorScheme = "Wings"
	elseif Visual_ColorSchemeBlast:GetChecked() then
		LyLock_Settings.Visual_ColorScheme = "Blast"
	elseif Visual_ColorSchemeTrees:GetChecked() then
		LyLock_Settings.Visual_ColorScheme = "Trees"
	end

	LyLock_Settings.Visual_LockFrames = iif(Visual_LockFrames:GetChecked(), true, false);
	LyLock_Settings.Visual_VerticalBar = iif(Visual_VerticalBar:GetChecked(), true, false);
	LyLock_Settings.Visual_ButtonSize = Visual_ButtonSize:GetValue();
	LyLock_Settings.Visual_ButtonSpace = Visual_ButtonSpace:GetValue();
	

	LyLock_ApplyVisualSettings()
	
end
function LyLock_LoadSettingsFrame()
	DemonArmor_ReadyUse:SetChecked(LyLock_Settings.DemonArmor_ReadyUse);
	DemonArmor_Unbuffed:SetChecked(LyLock_Settings.DemonArmor_Unbuffed>0);

	Healthstone_UseCombat:SetChecked(LyLock_Settings.Healthstone_UseCombat);
	Healthstone_HealthCap:SetChecked(LyLock_Settings.Healthstone_HealthCap);
	Healthstone_TradeRequest:SetChecked(LyLock_Settings.Healthstone_TradeRequest);
	Healthstone_TradeCombat:SetChecked(LyLock_Settings.Healthstone_TradeCombat);
	Healthstone_TradeRaiding:SetChecked(LyLock_Settings.Healthstone_TradeRaiding);

	Summoning_Casting:SetChecked(LyLock_Settings.Summoning_Casting);
	Summoning_Mounting:SetChecked(LyLock_Settings.Summoning_Mounting);
	Summoning_Message1:SetText(LyLock_Settings.Summoning_Message1);
	Summoning_Message2:SetText(LyLock_Settings.Summoning_Message2);

	Soulstone_Cooldown:SetChecked(LyLock_Settings.Soulstone_Cooldown);
	Soulstone_Unbuffed:SetChecked(LyLock_Settings.Soulstone_Unbuffed>0);
	Soulstone_WarnSelf:SetChecked(LyLock_Settings.Soulstone_WarnSelf>0);
	Soulstone_Casting:SetChecked(LyLock_Settings.Soulstone_Casting);
	Soulstone_Whisper:SetChecked(LyLock_Settings.Soulstone_Whisper);
	Soulstone_Warlocks:SetChecked(LyLock_Settings.Soulstone_Warlocks);

	Soulstone_Message1:SetText(LyLock_Settings.Soulstone_Message1);
	Soulstone_Message2:SetText(LyLock_Settings.Soulstone_Message2);
	Soulstone_Message3:SetText(LyLock_Settings.Soulstone_Message3);
	
	Banish_Disable:SetChecked(LyLock_Settings.Banish_Disable);
	Banish_Countdown:SetChecked(LyLock_Settings.Banish_Countdown);
	Banish_Casting:SetChecked(LyLock_Settings.Banish_Casting);
	Banish_Fading:SetChecked(LyLock_Settings.Banish_Fading);
	Banish_Warlocks:SetChecked(LyLock_Settings.Banish_Warlocks);

	Banish_Message1:SetText(LyLock_Settings.Banish_Message1);
	Banish_Message2:SetText(LyLock_Settings.Banish_Message2);
	Banish_Message3:SetText(LyLock_Settings.Banish_Message3);
	Banish_Message4:SetText(LyLock_Settings.Banish_Message4);
	
	SoulShard_UseBag0:SetChecked(LyLock_Settings.SoulShard_UseBag0);
	SoulShard_UseBag1:SetChecked(LyLock_Settings.SoulShard_UseBag1);
	SoulShard_UseBag2:SetChecked(LyLock_Settings.SoulShard_UseBag2);
	SoulShard_UseBag3:SetChecked(LyLock_Settings.SoulShard_UseBag3);
	SoulShard_UseBag4:SetChecked(LyLock_Settings.SoulShard_UseBag4);
	
	Visual_ColorSchemePinky:SetChecked(LyLock_Settings.Visual_ColorScheme == "Pinky");
	Visual_ColorSchemeWings:SetChecked(LyLock_Settings.Visual_ColorScheme == "Wings");
	Visual_ColorSchemeBlast:SetChecked(LyLock_Settings.Visual_ColorScheme == "Blast");
	Visual_ColorSchemeTrees:SetChecked(LyLock_Settings.Visual_ColorScheme == "Trees");

	Visual_LockFrames:SetChecked(LyLock_Settings.Visual_LockFrames);
	Visual_VerticalBar:SetChecked(LyLock_Settings.Visual_VerticalBar);
	Visual_ButtonSize:SetValue(LyLock_Settings.Visual_ButtonSize);
	Visual_ButtonSpace:SetValue(LyLock_Settings.Visual_ButtonSpace);

	
end
function LyLock_ApplyVisualSettings()
	SetColorScheme(LyLock_Settings.Visual_ColorScheme)
	SetActionBarPos(LyLock_Settings.Visual_VerticalBar, LyLock_Settings.Visual_ButtonSize, LyLock_Settings.Visual_ButtonSpace)

end

function SetActionBarPos(vert, size, space)
	SetActionButtonPos(LyLockSummonButton, vert, size, -1)
	SetActionButtonPos(LyLockDemonArmorButton, vert, size, space)
	SetActionButtonPos(LyLockHealthstoneButton, vert, size, space)
	SetActionButtonPos(LyLockSoulstoneButton, vert, size, space)
	SetActionButtonPos(LyLockSoulShardButton, vert, size, space)
	
end

function SetActionButtonPos(frame, vert, size, space)
	frame:SetWidth(size+2);
	frame:SetHeight(size+2);
	local point, sub, to, offsetx, offsety = frame:GetPoint();
	if vert then
		frame:SetPoint(point, sub, to, iif((space==-1), offsetx, 0), iif((space==-1), offsety, 0) + -iif((space==-1), 0, space + size));
	else
		frame:SetPoint(point, sub, to, iif((space==-1), offsetx, 0) + iif((space==-1), 0, space + size), iif((space==-1), offsety, 0));
	end
end

--------------------------------------------------------------------------------------
-- Watched Events --------------------------------------------------------------------
--------------------------------------------------------------------------------------

LYLOCK_WATCHEDEVENTS = {
	"CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE",
	"CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE",
	"CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE",
	"CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE",
	"CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE",
	"CHAT_MSG_SPELL_BREAK_AURA",
	"CHAT_MSG_SPELL_AURA_GONE_SELF",
	"CHAT_MSG_SPELL_AURA_GONE_OTHER",

	"CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS",
	"CHAT_MSG_SPELL_SELF_BUFF",

	"PLAYER_TARGET_CHANGED",
	"PLAYER_DEAD",

	"SPELLCAST_START",
	"SPELLCAST_FAILED",
	"SPELLCAST_INTERRUPTED",
	"SPELLCAST_DELAYED",
	"SPELLCAST_STOP",

	"UNIT_AURA",

	"TRADE_REQUEST",
	"TRADE_REQUEST_CANCEL",
	"TRADE_ACCEPT_UPDATE",
	"TRADE_SHOW",
	"TRADE_CLOSED"
}



--------------------------------------------------------------------------------------
-- LyLock Main Functions -------------------------------------------------------------
--------------------------------------------------------------------------------------

function LyLock_OnLoad()

	if LyLock_Defaults() then

		this:RegisterEvent("VARIABLES_LOADED");
		this:RegisterEvent("PLAYER_ENTERING_WORLD");
		this:RegisterEvent("PLAYER_LEAVING_WORLD");

		SlashCmdList["LyLock"] = LyLock_AddOnHandler;
		SLASH_LyLock1 = "/lylock";

		SlashCmdList["LyLockSoulstoneTarget"] = SoulstoneTarget;
		SLASH_LyLockSoulstoneTarget1 = "/soulstonetarget";
	
		SlashCmdList["LyLockUseDemonArmor"] = UseDemonArmor;
		SLASH_LyLockUseDemonArmor1 = "/usedemonarmor";

		SlashCmdList["LyLockSummonTarget"] = SummonTarget;
		SLASH_LyLockSummonTarget1 = "/summontarget";	
		SlashCmdList["LyLockUseHealthstone"] = UseHealthstone;
		SLASH_LyLockUseHealthstone1 = "/usehealthstone";	


	end
end


function LyLock_OnEvent(event, arg1, arg2, arg3, arg4, arg5)

	if event=="VARIABLES_LOADED" then

		if LyLock_Defaults() then
			LyLock_ApplyVisualSettings()
			EchoColor("LyLock", COLOR_HEADER, LYLOCK_VERSION.." Loaded.  For configuration type /LyLock")
		end

	elseif event=="PLAYER_ENTERING_WORLD" then

		LyLockSummonButton:Show();
		LyLockDemonArmorButton:Show();
		LyLockHealthstoneButton:Show();
		LyLockSoulstoneButton:Show();
		LyLockSoulShardButton:Show();
		for index, event in LYLOCK_WATCHEDEVENTS do
			this:RegisterEvent(event);
		end

	elseif event=="PLAYER_LEAVING_WORLD" then

		for index, event in LYLOCK_WATCHEDEVENTS do
			this:UnregisterEvent(event);
		end
		LyLockSummonButton:Hide();
		LyLockDemonArmorButton:Hide();
		LyLockHealthstoneButton:Hide();
		LyLockSoulstoneButton:Hide();
		LyLockSoulShardButton:Hide();
	else
		Summoning_OnEvent()
		Soulstone_OnEvent()
		Healthstone_OnEvent()
		Banish_OnEvent()
	end
end

updateStarted = GetTime()
function LyLock_OnUpdate()
	if (GetTime()-updateStarted)>=1 then
		updateStarted = GetTime()
		
		Soulstone_OnUpdate()
		DemonArmor_OnUpdate()
		Banish_OnUpdate()
		Healthstone_OnUpdate()
		SoulShard_OnUpdate()
	end
end

function LyLock_OnDragStart(button)
	if not LyLock_Settings.Visual_LockFrames then
		LyLockSummonButton:StartMoving();
	end
end
function LyLock_OnDragStop(button)
	LyLockSummonButton:StopMovingOrSizing();
end
function LyLock_AddOnHandler(msg)
	LyLock_SettingsFrameAction("Open");
end



--------------------------------------------------------------------------------------
-- Demon Armor Functions -------------------------------------------------------------
--------------------------------------------------------------------------------------

demonArmorMessage=0

function DemonArmor_OnUpdate()

	if UnitIsDeadOrGhost("player")==nil then
		if not IsUnitDemonArmor() then
			if UnitMana("player")>=1580 then
				if demonArmorMessage==0 then
					demonArmorMessage = GetTime()
					if LyLock_Settings.DemonArmor_ReadyUse then
						EchoMessage("LyLock", "Demon Armor is now ready to be used", "ReadyUse")
						LyLockDemonArmorReadyText:SetText(LYLOCK_FLAGCAST)
					end
				else
					if LyLock_Settings.DemonArmor_Unbuffed>0 then
						if (GetTime()-demonArmorMessage)>=(LyLock_Settings.DemonArmor_Unbuffed*60) then
							demonArmorMessage = GetTime()
							EchoMessage("LyLock", "Demon Armor has not been casted on yourself", "UnBuffed")
							LyLockDemonArmorReadyText:SetText(LYLOCK_FLAGCAST)
						end
					end
				end
			end
		else
			LyLockDemonArmorReadyText:SetText(LYLOCK_FLAGNONE)
			demonArmorMessage=0
		end
	end
end
function CastDemonArmor()
	local id = nil
	if id==nil then id = GetSpellID("Demon Armor") end
	if id==nil then id = GetSpellID("Demon Skin") end
	if id==nil then
		EchoMessage("LyLock", "Demon Armor spell not found in spell book", "Canceled")
	else
		CastSpell(id, 1)
	end	
end
function UseDemonArmor()
	CastDemonArmor()
end

function IsUnitDemonArmor()
	return IsUnitBuff("player", "Spell_Shadow_RagingScream")
end

--------------------------------------------------------------------------------------
-- Soulstone Functions ---------------------------------------------------------------
--------------------------------------------------------------------------------------

soulstoneStarted=0
soulstoneMessage=0
soulstonePlayer=nil

soulstoneGroup=false
soulstoneNames={}

function Soulstone_OnUpdate()
	if (soulstonePlayer~=nil) then
		if IsPlayerSoulstoned(soulstonePlayer) then
			local toplayer = soulstonePlayer
			soulstonePlayer = nil
			soulstoneStarted = GetTime()
			if LyLock_Settings.Soulstone_Whisper then
				WhisperName(toplayer, LyMsg(LyLock_Settings.Soulstone_Message2, toplayer))
			end
			if LyLock_Settings.Soulstone_Warlocks then
				WhisperWarlocks(toplayer, LyMsg(LyLock_Settings.Soulstone_Message3, toplayer))
			end
		end
	end


	local ssTime=-1
	GetContainerItemByName("Soulstone")
	if (itemBagNum~=-1) then
		local za, zb, zc=GetContainerItemCooldown(itemBagNum, itemSlotNum);
		if (za>0) then
			ssTime=(GetTime()-za)
		else
			ssTime=0
		end
	end
	if (ssTime==-1) then
		if (soulstoneStarted~=0) then
			ssTime = (GetTime() - soulstoneStarted)
			if ssTime>1800 then
				ssTime = 0
			end
		end
	end


	if (ssTime>0) then
		LyLockSoulstoneCooldownText:SetText(strtimeM((1800-ssTime)));
	elseif (itemBagNum==-1) then
		LyLockSoulstoneCooldownText:SetText(LYLOCK_FLAGMAKE);
	elseif (ssTime==0) then
		LyLockSoulstoneCooldownText:SetText(LYLOCK_FLAGCAST);
	else
		LyLockSoulstoneCooldownText:SetText(LYLOCK_FLAGNONE);
	end


	if (ssTime>0) then
		if LyLock_Settings.Soulstone_Cooldown then
			if (ssTime>=1619) and (ssTime<1620) then
				EchoMessage("LyLock", "Soulstone will be ready in 3 Mins", "Cooldown")
			elseif (ssTime>=1679) and (ssTime<1680) then
				EchoMessage("LyLock", "Soulstone will be ready in 2 Mins", "Cooldown")
			elseif (ssTime>=1739) and (ssTime<1740) then
				EchoMessage("LyLock", "Soulstone will be ready in 1 Min", "Cooldown")
			elseif (ssTime>=1799) and (ssTime<1800) then
				EchoMessage("LyLock", "Soulstone is now ready to cast", "ReadyUse")
			end
		end
	end

	if ((GetNumPartyMembers()>0) or (GetNumRaidMembers()>0)) then
		if LyLock_Settings.Soulstone_Unbuffed>0 then
			local ssNames = GetSoulstonedNames()
				
			if ssNames[1]~=nil then
				soulstoneMessage=0
			else
				if ((GetTime()-soulstoneMessage)>=(LyLock_Settings.Soulstone_Unbuffed*60)) or (soulstoneMessage==0) or (not soulstoneGroup) then
					soulstoneMessage = GetTime()
					local wasdeath=false
					if soulstoneNames[1]~=nil then
						for i, pinfo in soulstoneNames do
							if UnitIsDeadOrGhost(pinfo.Unit) then
								EchoMessage("LyLock", "Soulstoned player "..pinfo.Name.." has died", "UnBuffed")
								wasdeath=true
							end
						end							
					end
					if not wasdeath then
						EchoMessage("LyLock", "Soulstone is not on any player in your group", "UnBuffed")
					end
				end
			end
			soulstoneNames = ssNames
		end
		soulstoneGroup = true
	else
		if LyLock_Settings.Soulstone_WarnSelf>0 then
			if IsUnitSoulstoned("player") then
				soulstoneMessage=0
			else
				if ((GetTime()-soulstoneMessage)>=(LyLock_Settings.Soulstone_WarnSelf*60)) or (soulstoneMessage==0) or soulstoneGroup then
					soulstoneMessage = GetTime()
					EchoMessage("LyLock", "Soulstone is not currently casted on youself", "UnBuffed")
				end
			end
		end
		soulstoneGroup = false
	end

end

function Soulstone_OnEvent()
	if event=="SPELLCAST_START" then
		if string.find(arg1, "Soulstone Resurrection") then
			soulstonePlayer = UnitName("target")
		end
	elseif event=="SPELLCAST_FAILED" or event=="SPELLCAST_INTERRUPTED" then
		if soulstonePlayer~=nil then
			soulstonePlayer = nil
		end
	end
end
function CastSoulstone()
	local id = nil
	if id==nil then id = GetSpellID("Create Soulstone (Major)") end
	if id==nil then id = GetSpellID("Create Soulstone (Greater)") end
	if id==nil then id = GetSpellID("Create Soulstone") end
	if id==nil then id = GetSpellID("Create Soulstone (Lesser)") end
	if id==nil then id = GetSpellID("Create Soulstone (Minor)") end
	if id==nil then
		EchoMessage("LyLock", "Soulstone spell not found in spell book", "Canceled")
	else
		CastSpell(id, 1)
	end	
end
function SoulstoneTarget()
	GetContainerItemByName("Soulstone")
	if itemBagNum==-1 then
		CastSoulstone()
	else
		local za, zb, zc=GetContainerItemCooldown(itemBagNum, itemSlotNum);
		if (za>0) or (UnitIsDeadOrGhost("player")==1) then
			if (za>0) then
				EchoMessage("LyLock", "Soulstone cooldown is "..strtime((1800-(GetTime()-za))), "Cooldown")
			else
				EchoMessage("LyLock", "Soulstone is ready to be used", "ReadyUse")
			end
		else
			if (UnitIsPlayer("target") and (UnitInParty("target") or UnitInRaid("target"))) then
				if CheckInteractDistance("target", 4) then
					UseContainerItem(itemBagNum,itemSlotNum)
					if (UnitName("target") ~= myname) then
						if LyLock_Settings.Soulstone_Casting then
							Speak(LyMsg(LyLock_Settings.Soulstone_Message1, UnitName("target")))
						else
							EchoMessage("LyLock", LyMsg(LyLock_Settings.Soulstone_Message1, UnitName("target")), "Casting")
						end
					end
				else
					EchoMessage("LyLock", "You are too far away to Soulstone that player", "Canceled")
				end
			else
				EchoMessage("LyLock", "Target a player in the raid or party to Soulstone", "Canceled")
			end
		end
	end
end

function GetSoulstonedNames()
	local n = 1
	local ret = {}
	if GetNumRaidMembers()>0 then
		for ii=1, MAX_RAID_MEMBERS do
			local name = UnitName("raid"..ii)
			if name~=nil and name~=myname then
				if IsUnitSoulstoned("raid"..ii) then
					ret[n]={}
					ret[n].Name = name
					ret[n].Unit = "raid"..ii
					n=n+1
				end
			end
		end
	elseif GetNumPartyMembers()>0 then
		for ii=1, MAX_PARTY_MEMBERS  do
			local name = UnitName("party"..ii)
			if name~=nil and name~=myname then
				if IsUnitSoulstoned("party"..ii) then
					ret[n]={}
					ret[n].Name = name
					ret[n].Unit = "party"..ii
					n=n+1
				end
			end
		end
	end
	if IsUnitSoulstoned("player") then
		ret[n]={}
		ret[n].Name = myname
		ret[n].Unit = "player"
		n=n+1
	end
	return ret
end

function IsGroupSoulstoned()
	if GetNumRaidMembers()>0 then
		for ii=1, MAX_RAID_MEMBERS do
			local name = UnitName("raid"..ii)
			if name~=nil and name~=myname then
				if IsUnitSoulstoned("raid"..ii) then
					return true
				end
			end
		end
	elseif GetNumPartyMembers()>0 then
		for ii=1, MAX_PARTY_MEMBERS  do
			local name = UnitName("party"..ii)
			if name~=nil and name~=myname then
				if IsUnitSoulstoned("party"..ii) then
					return true
				end
			end
		end
	end
	return IsUnitSoulstoned("player")
end

function IsPlayerSoulstoned(player)
	if UnitName("target") == player then
		return IsUnitSoulstoned("target")
	elseif myname==player then
		return IsUnitSoulstoned("player")
	elseif GetNumRaidMembers()>0 then
		for ii=1, MAX_RAID_MEMBERS do
			local name = UnitName("raid"..ii)
			if name~=nil and player==name then
				if IsUnitSoulstoned("raid"..ii) then
					return true
				end
			end
		end
	elseif GetNumPartyMembers()>0 then
		for ii=1, MAX_PARTY_MEMBERS  do
			local name = UnitName("party"..ii)
			if name~=nil and player==name then
				if IsUnitSoulstoned("party"..ii) then
					return true
				end
			end
		end
	end

	TargetByName(player, true)
	if IsUnitSoulstoned("target") then
		TargetLastTarget()
		return true
	else
		TargetLastTarget()
		return false		
	end
end

function IsUnitSoulstoned(unit)
	return IsUnitBuff(unit, "Spell_Shadow_SoulGem")
end


--------------------------------------------------------------------------------------
-- Healthstone Functions -------------------------------------------------------------
--------------------------------------------------------------------------------------
healthstoneStarted = 0
healthstoneTrading = false
healthstonePlaced = false

function Healthstone_OnUpdate()
	if healthstoneTrading and (not healthstonePlaced) then
		if (not LyLock_Settings.Healthstone_TradeRaiding) then
			PlaceHealthstoneInTrade()
		elseif (GetNumRaidMembers()>0) or (GetNumPartyMembers()>0) then
			PlaceHealthstoneInTrade()
		end
	end
	

	local ssTime=-1
	GetContainerItemByName("Healthstone")
	if (itemBagNum~=-1) then
		local za, zb, zc=GetContainerItemCooldown(itemBagNum, itemSlotNum);
		if (za>0) then
			ssTime=(GetTime()-za)
		else
			ssTime=0
		end
	end
	if (ssTime==-1) then
		if (healthstoneStarted~=0) then
			ssTime = (GetTime() - healthstoneStarted)
			if ssTime>120 then
				ssTime = 0
			end
		end
	end



	if (ssTime>0) then
		LyLockHealthstoneCooldownText:SetText(strtimeM((120-ssTime)));
	elseif (itemBagNum==-1) then
		LyLockHealthstoneCooldownText:SetText(LYLOCK_FLAGMAKE);
	elseif (ssTime==0) then
		LyLockHealthstoneCooldownText:SetText(LYLOCK_FLAGCAST);
	else
		LyLockHealthstoneCooldownText:SetText(LYLOCK_FLAGNONE);
	end
		
end
function PlaceHealthstoneInTrade()
	GetContainerItemByName("Healthstone")
	if GetContainerItemByName("Healthstone") then
		PickupContainerItem(itemBagNum, itemSlotNum);
		ClickTradeButton(1);
		healthstonePlaced=true
	end	
end
function Healthstone_OnEvent()
	if event=="TRADE_SHOW" or event=="TRADE_REQUEST" then
		if LyLock_Settings.Healthstone_TradeRequest then
			if UnitAffectingCombat("player")==nil then
				healthstonePlaced=false
				healthstoneTrading=true
			elseif not LyLock_Settings.Healthstone_TradeCombat then
				healthstonePlaced=false
				healthstoneTrading=true
			end
		end
	elseif event=="TRADE_CLOSED" or event=="TRADE_REQUEST_CANCEL" then
		healthstoneTrading=false
		healthstonePlaced=false
	elseif event=="TRADE_ACCEPT_UPDATE" then
		if healthstoneTrading and healthstonePlaced then
			AcceptTrade()
		end
	end
	
end

function CastHealthstone()
	local id = nil
	if id==nil then id = GetSpellID("Create Healthstone (Major)") end
	if id==nil then id = GetSpellID("Create Healthstone (Greater)") end
	if id==nil then id = GetSpellID("Create Healthstone") end
	if id==nil then id = GetSpellID("Create Healthstone (Lesser)") end
	if id==nil then id = GetSpellID("Create Healthstone (Minor)") end
	if id==nil then
		EchoMessage("LyLock", "Healthstone spell not found in spell book", "Canceled")
	else
		CastSpell(id, 1)
	end	
end
function UseHealthstone()
	if not GetContainerItemByName("Healthstone") then
		CastHealthstone()
	else
		local za, zb, zc=GetContainerItemCooldown(itemBagNum, itemSlotNum);
		if (za>0) or (UnitIsDeadOrGhost("player")==1) then
			if za>0 then
				EchoMessage("LyLock", "Healthstone cooldown is "..strtime( (120-(GetTime()-za)) ), "Cooldown")
			else
				EchoMessage("LyLock", "Healthstone is ready to be used", "ReadyUse")
			end
		else
			local use = true
			if LyLock_Settings.Healthstone_UseCombat then
				if UnitAffectingCombat("player")==nil then
					use = false
					EchoMessage("LyLock", "You must be in combat to use a Healthstone", "Canceled")
				end
			end
			if use then
				if LyLock_Settings.Healthstone_HealthCap then
					local max = UnitHealthMax("player")
					local cur = UnitHealth("player")
					if ((max-cur)<=1000) then
						use = false
						EchoMessage("LyLock", "Your health is not low enough to use a Healthstone", "Canceled")
					end
				end
			end
			if use then
				UseContainerItem(itemBagNum,itemSlotNum)
				healthstoneStarted = GetTime()
			end
		end
	end
end

--------------------------------------------------------------------------------------
-- Summon Functions ------------------------------------------------------------------
--------------------------------------------------------------------------------------
function Summoning_OnEvent()
	if event=="CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS" then
		if arg1=="You gain Summon Dreadsteed." or arg1=="You gain Summon Felsteed." then
			if LyLock_Settings.Summoning_Mounting then
				SendChatMessage(LyMsg(LyLock_Settings.Summoning_Message2, ""),"SAY")
			end
		end
	end
end

function SummonTarget()
	if (UnitIsPlayer("target") and ((UnitInParty("target") or UnitInRaid("target")) and (UnitName("target") ~= UnitName("player")))) then
		if CheckInteractDistance("target", 4)==nil then
			CastSpellByName("Ritual of Summoning()");
			if LyLock_Settings.Summoning_Casting then
				Speak(LyMsg(LyLock_Settings.Summoning_Message1, UnitName("target")))
			end
		else
			EchoMessage("LyLock", "The targeted player is already near you", "Canceled")
		end
	else
		EchoMessage("LyLock", "Target a player in the raid or party to summon", "Canceled")
	end
end

--------------------------------------------------------------------------------------
-- Banish Functions ------------------------------------------------------------------
--------------------------------------------------------------------------------------

banishStarted=0
banishElapse=0
banishHostile=nil
banishCasted=false
banishTarget=false
banishBroke=false

function Banish_OnEvent()
	
	if event=="CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE" or event=="CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE" then

		if string.find(arg1, "Banish") then
			if banishHostile~=nil then 
				if string.find(arg1, banishHostile) then
					if string.find(arg1, "afflicted") then
						if banishCasted and not banishBroke and not banishTarget and not LyLock_Settings.Banish_Disable then
							EchoMessage("LyLock", "Your Banishing two targets", "Canceled")
						end
						banishStarted = GetTime()
						banishCasted = true
						banishBroke = false
						banishTarget = true
						if not LyLock_Settings.Banish_Disable then
							if LyLock_Settings.Banish_Casting then
								Speak(LyMsg(LyLock_Settings.Banish_Message1, banishHostile))
							else
								EchoMessage("LyLock", LyMsg(LyLock_Settings.Banish_Message1, banishHostile), "Casting")
							end
						end
					elseif (string.find(arg1, "resisted") or string.find(arg1, "immune")) then
						banishHostile = nil
						banishCasted = false			
					end
				end
			end
		end
	elseif (event == "CHAT_MSG_SPELL_BREAK_AURA" or event=="CHAT_MSG_SPELL_AURA_GONE_OTHER") then
		if string.find(arg1, "Banish") then
			if banishCasted and not banishBroke then
				if string.find(arg1, banishHostile) then
					if banishTarget then
						banishBroke = true
						banishCasted = false
						if not LyLock_Settings.Banish_Disable then
							if LyLock_Settings.Banish_Fading then
								Speak(LyMsg(LyLock_Settings.Banish_Message3, banishHostile))
							else
								EchoMessage("LyLock", LyMsg(LyLock_Settings.Banish_Message3, banishHostile), "Fading")
							end
						end
					end
				end
			end
		end
	elseif event == "PLAYER_TARGET_CHANGED" then
		banishTarget = IsUnitBanished("target")
	elseif event == "PLAYER_DEAD" then
		if LyLock_Settings.Banish_Warlocks then
			if (UnitIsDeadOrGhost("player")==1) then
				if not LyLock_Settings.Banish_Disable then
					if (banishHostile~=nil) and banishCasted then
						WhisperWarlocks(LyMsg(LyLock_Settings.Banish_Message4, banishHostile)) --casted a banish
					elseif (banishHostile~=nil) and not banishCasted then
						WhisperWarlocks(LyMsg(LyLock_Settings.Banish_Message4, banishHostile)) --attempted a banish
					end
				end
			end
		end
	elseif event == "SPELLCAST_START" then
		if arg1=="Banish" then
			banishHostile = UnitName("target")
		end
	elseif event == "SPELLCAST_INTERRUPTED" or event == "SPELLCAST_FAILED" then
		if (banishHostile~=nil) and not banishCasted then
			banishAttempt = nil
		end
	end
end


function Banish_OnUpdate()
	if banishCasted and not banishBroke then
		banishElapse = (GetTime() - banishStarted)
		if LyLock_Settings.Banish_Countdown and not LyLock_Settings.Banish_Disable then
			if banishElapse>=14 and banishElapse<15 then
				EchoMessage("LyLock", "Banish will fade in 15 Sec", "Countdown")
			elseif banishElapse>=19 and banishElapse<20 then
				EchoMessage("LyLock", "Banish will fade in 10 Sec", "Countdown")
			elseif banishElapse>=24 and banishElapse<25 then
				EchoMessage("LyLock", "Banish will fade in 5 Sec", "Countdown")
			end
		end
		
		if banishElapse>=28 then
			banishBroke = true
			banishCasted = false
			if not LyLock_Settings.Banish_Disable then
				if LyLock_Settings.Banish_Fading then
					Speak(LyMsg(LyLock_Settings.Banish_Message2, banishHostile))
				else
					EchoMessage("LyLock", LyMsg(LyLock_Settings.Banish_Message2, banishHostile), "Fading")
				end
			end
		end
	end
end

function IsUnitBanished(unit)
	return IsUnitDebuff(unit, "Spell_Shadow_Cripple")
end



--------------------------------------------------------------------------------------
-- SoulShard Functions ---------------------------------------------------------------
--------------------------------------------------------------------------------------
function SoulShard_OnUpdate()
	local shards = 0
	for i=0,4 do
		for c=1,GetContainerNumSlots(i) do
			y=GetContainerItemLink(i,c)
			if y and string.find(y,"Soul Shard") then
				shards=shards+1
			end
		end
	end
	SortSoulShards();
	LyLockSoulShardCountText:SetText(tostring(shards));
end

function DrainSoulTarget()
	local id = nil
	if id==nil then id = GetSpellID("Drain Soul") end
	if id==nil then
		EchoMessage("LyLock", "Drain Soul spell not found in spell book", "Canceled")
	else
		CastSpell(id, 1)
	end	
end

function FirstFreeSlot(inbag)
	for inslot=1, GetContainerNumSlots(inbag) do
		if GetContainerItemLink(inbag, inslot)==nil then
			return inslot
		end
	end
	return nil
end

function SortSoulShards()
	local useBag = UseSoulShardBag(0, LyLock_Settings.SoulShard_UseBag0)
	if (useBag==nil) then useBag = UseSoulShardBag(1, LyLock_Settings.SoulShard_UseBag1) end
	if (useBag==nil) then useBag = UseSoulShardBag(2, LyLock_Settings.SoulShard_UseBag2) end
	if (useBag==nil) then useBag = UseSoulShardBag(3, LyLock_Settings.SoulShard_UseBag3) end
	if (useBag==nil) then useBag = UseSoulShardBag(4, LyLock_Settings.SoulShard_UseBag4) end
	if (useBag~=nil) then
		for bag=0, 4 do
			if (GetBagName(bag)~=nil) then
				if not IsSoulShardBag(bag) then
					for slot=1, GetContainerNumSlots(bag) do
						local texture, itemCount, locked, quality, readable = GetContainerItemInfo(bag, slot);
						if texture~=nil then
							if string.find(texture,"INV_Misc_Gem_Amethyst_02") then
								local useSlot = FirstFreeSlot(useBag)
								if useSlot==nil then return end
								PickupContainerItem(bag, slot);
								PickupContainerItem(useBag, useSlot);
							end
						end					
					end
				end
			end
		end
	end
end
function UseSoulShardBag(inbag, isuse)
	if isuse and (GetBagName(inbag)~=nil) then
		if (FirstFreeSlot(inbag)~=nil) then return inbag end
	end	
	return nil
end
function IsSoulShardBag(inbag)
	if inbag==0 and LyLock_Settings.SoulShard_UseBag0 then return true end
	if inbag==1 and LyLock_Settings.SoulShard_UseBag1 then return true end
	if inbag==2 and LyLock_Settings.SoulShard_UseBag2 then return true end
	if inbag==3 and LyLock_Settings.SoulShard_UseBag3 then return true end
	if inbag==4 and LyLock_Settings.SoulShard_UseBag4 then return true end
	return false
end
--------------------------------------------------------------------------------------
-- Message Functions -----------------------------------------------------------------
--------------------------------------------------------------------------------------
function LyMsg(str, tar)
	return strvars(str, tar)
end

function WhisperWarlocks(toplayer, msg)
	if GetNumRaidMembers()>0 then
		for i=1, MAX_RAID_MEMBERS do
			name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i)
			WhisperWarlock(toplayer, name, class, msg)
		end
	elseif GetNumPartyMembers()>0 then
		for i=1, MAX_PARTY_MEMBERS  do
			local name = UnitName("party"..i)
			WhisperWarlock(toplayer, UnitName("party"..i), UnitClass("party"..i), msg)
		end
	end
end
function WhisperWarlock(toplayer, name, class, msg)
	if name~=nil then
		if class=="Warlock" then
			if (name~=toplayer) or ((name==toplayer) and (not LyLock_Settings.Soulstone_Whisper)) then
				WhisperName(name, msg)
			end
		end
	end
end

