--------------------------------------------------------------------------------------
-- Color Constants -------------------------------------------------------------------
--------------------------------------------------------------------------------------

COLOR_WHITE = "|CFFFFFFFF"
COLOR_LIGHTBLUE = "|CFF99CCFF"
COLOR_BRIGHTGREEN = "|CFF00FF00"
COLOR_LIGHTGREEN2 = "|CFF66FF66"
COLOR_LIGHTGREEN1 = "|CFF99FF66"
COLOR_YELLOWGREEN = "|CFFCCFF66"
COLOR_LIGHTYELLOW = "|CFFFFFF66"
COLOR_RED = "|CFFFF0000"
COLOR_LIGHTRED = "|CFFFF5555"
COLOR_LIGHTPURPLE1 = "|CFFFFC4FF"
COLOR_LIGHTPURPLE2 = "|CFFFF99FF"
COLOR_PURPLE = "|CFFFF50FF"
COLOR_DARKPURPLE1 = "|CFFFF00FF"
COLOR_DARKPURPLE2 = "|CFFB700B7"
COLOR_DARKYELLOW = "|CFFFFCC00"
COLOR_LIGHTORANGE = "|CFFFFCC66"
COLOR_DIRTYORANGE = "|CFFFF9933"
COLOR_DARKORANGE = "|CFFFF6600"
COLOR_REDORANGE = "|CFFFF3300"

COLOR_NORMAL = "|CFFEBEBFF"
COLOR_ERROR = "|CFF4040FF"
COLOR_HEADER = "|CFF8080FF"
COLOR_VALUE = "|CFF8080FF"
COLOR_NOTIFY = "|CFFC0C0FF"
COLOR_TITLE = "|CFF2065C2"
COLOR_BRACKET = "|CFF01059D"


--------------------------------------------------------------------------------------
-- Message Functions -----------------------------------------------------------------
--------------------------------------------------------------------------------------


function EchoMessage(prefix, txt, msg)
	DEFAULT_CHAT_FRAME:AddMessage(COLOR_BRACKET.."["..COLOR_TITLE..prefix..COLOR_BRACKET.."] "..COLOR_NOTIFY..txt.." "..COLOR_BRACKET.."["..COLOR_TITLE..msg..COLOR_BRACKET.."]",1,1,0)
end


function EchoColor(prefix, color, txt)
	DEFAULT_CHAT_FRAME:AddMessage(COLOR_BRACKET.."["..COLOR_TITLE..prefix..COLOR_BRACKET.."] "..color..txt,1,1,0)
end

function Echo(txt)
	DEFAULT_CHAT_FRAME:AddMessage(COLOR_BRACKET.."["..COLOR_TITLE.."Echo"..COLOR_BRACKET.."] "..COLOR_NORMAL..txt.." "..COLOR_BRACKET.."["..COLOR_TITLE.."Debug"..COLOR_BRACKET.."]",1,1,0)
end

function EchoDebug(txt)
	if LYLOCK_DEBUG then
		DEFAULT_CHAT_FRAME:AddMessage(COLOR_BRACKET.."["..COLOR_TITLE.."Debug"..COLOR_BRACKET.."] "..COLOR_NORMAL..txt.." "..COLOR_BRACKET.."["..COLOR_TITLE.."Debug"..COLOR_BRACKET.."]",1,1,0)
	end
end

function EchoEvent()
	if arg1==nil then arg1="nil" end
	if arg2==nil then arg2="nil" end
	if arg3==nil then arg3="nil" end
	if arg4==nil then arg4="nil" end
	if arg5==nil then arg5="nil" end
	if event==nil then event="nil" end
	Echo(event.."("..arg1..", "..arg2..", "..arg3..", "..arg4..", "..arg5..")")
end
function Speak(txt)
	if GetNumRaidMembers()>0 then
		SendChatMessage("<<"..txt..">>","RAID")
	elseif GetNumPartyMembers()>0 then
		SendChatMessage("<<"..txt..">>","PARTY")
	else
		SendChatMessage("<<"..txt..">>","SAY")
	end
end
function WhisperName(name, msg)
	if (name ~= UnitName("player")) then
		SendChatMessage("<<"..msg..">>", "WHISPER", nil, name)
	end	
end

--------------------------------------------------------------------------------------
-- Various Functions -----------------------------------------------------------------
--------------------------------------------------------------------------------------

itemBagNum=-1
itemSlotNum=0
function GetContainerItemByName(item)
	itemBagNum=-1; itemSlotNum=0;
	for i=0,4 do
		for c=1,GetContainerNumSlots(i) do
			y=GetContainerItemLink(i,c)
			if y and string.find(y,item) then
				itemBagNum=i;itemSlotNum=c;
				return true;
			end
		end
	end
	return false;
end

function ReturnSetting(value, default)
	return iif(((value==nil) or (value=="")),default,value)
end

function IsInCombat(unit)
	return UnitAffectingCombat(unit)
end

function IsUnitBuff(unit, texture)
	for i=1, 16 do
		local a,b = UnitBuff(unit, i)
		if a~=nil then
	    		if (string.find(a, texture)) then
      				return true
    			end
		end
	end
	return false
end
function DebugUnitBuffs(unit)
	local i= 1
	for i=1, 16 do
		local a,b = UnitBuff(unit, i)
		if a~=nil then
			EchoDebug("Buff: "..a)
		end
	end
	return false
end

function IsUnitDebuff(unit, texture) 
	local i= 1
	for i=1, 16 do
		local a,b = UnitDebuff(unit, i)
		if a~=nil then
	    		if (string.find(a, texture)) then
      				return true
    			end
		end
	end
	return false
end

function iif(exp,rtrue,rfalse)
	if exp then
		return rtrue
	else
		return rfalse
	end
end
function strstrip(str, fnd)
	local i = string.find(str, fnd)
	if i~=nil then
		return strsub(str, 0, i-1)..strsub(str, (i+strlen(fnd)), strlen(str))
	else
		return str
	end
end

function strvars(str, tar)
	local ret = str

	ret = string.gsub(ret, "%%(target)%%", tar)
	ret = string.gsub(ret, "%%(target)", tar)
	ret = string.gsub(ret, "%%(t)%%", tar)
	ret = string.gsub(ret, "%%(t)", tar)
	
	ret = string.gsub(ret, "%%(%w+)%%", UnitName)
	ret = string.gsub(ret, "%%(%w+)", UnitName)
	
	return ret
end


function strtime(secs)
	local tim = SecondsToTime(secs)
	return strsub(tim, 0, (strlen(tim)-2)) 
end
function strtimeMin(secs)
	local tim = SecondsToTime(secs)
	if string.find(tim, "Min") then
		local min = tonumber(strsub(tim,0 , string.find(tim, " ")-1))
		if string.find(tim, "Sec") then min = min+1 end
		return iif((min==1),min.." Min",iif((min>1),min.." Mins",""))
	else
		return tim
	end
end
function strtimeM(secs)
	local tim = SecondsToTime(secs)
	if string.find(tim, "Min") then
		local min = tonumber(strsub(tim,0 , string.find(tim, " ")-1))
		if string.find(tim, "Sec") then min = min+1 end
		return iif((min>=1),min.."m","")
	elseif string.find(tim, "Sec") then
		local sec = tonumber(strsub(tim,0 , string.find(tim, " ")-1))
		return iif((sec>=1),sec.."s","")
	end
end
function WaitSeconds(x)
	tmp = GetTime()
	repeat
		tmp2= GetTime()
	until tmp2-tmp>x
end

function GetSpellID(spellname)
	local i,done,name,id,spellrank=1,false;
	_,_,spellrank = string.find(spellname,"%((Rank %d+)%)");
	spellname = string.gsub(spellname,"%(Rank %d+%)","");
	while not done do
		name,rank = GetSpellName(i,BOOKTYPE_SPELL);
		if not name then
			done=true;
		elseif (name==spellname and not spellrank) or (name==spellname and rank==spellrank) then
			id = i;
		end
		i = i+1;
	end
	return id
end
function GetContainerTextureByName(item)
	GetContainerItemByName(item)
	local texture, itemCount, locked, quality, readable = GetContainerItemInfo(itemBagNum,itemSlotNum);
	Echo(texture);
end
